#include "GeoExample.h"

#include "G4Box.hh"
#include "G4LogicalVolume.hh"
#include "G4NistManager.hh"
#include "G4PVPlacement.hh"

G4VPhysicalVolume *GeoExample::Construct() {
  G4Box *worldSolid = new G4Box("worldSolid", 5 * CLHEP::cm, 5 * CLHEP::cm, 5 * CLHEP::cm);
  G4LogicalVolume *worldLogic =
      new G4LogicalVolume(worldSolid, G4NistManager::Instance()->FindOrBuildMaterial("G4_Galactic"), "worldLogic");

  G4Box *cubeSolid = new G4Box("cubeSolid", 0.5 * CLHEP::cm, 0.5 * CLHEP::cm, 0.5 * CLHEP::cm);
  G4LogicalVolume *cubeLogic =
      new G4LogicalVolume(cubeSolid, G4NistManager::Instance()->FindOrBuildMaterial("G4_Galactic"), "cubeLogic");
  new G4PVPlacement(nullptr, G4ThreeVector(0.1 * CLHEP::cm, 0.2 * CLHEP::cm, -0.3 * CLHEP::cm), cubeLogic, "cubePhys",
                    worldLogic, false, 0);

  return new G4PVPlacement(nullptr, G4ThreeVector(0, 0, 0), worldLogic, "worlPhys", NULL, false, 0);
}
