#include "G4GDMLParser.hh"
#include "Geant4GM/volumes/Factory.h"
#include "GeoExample.h"
#include "RootGM/volumes/Factory.h"
#include "TGeoManager.h"

#include <cstdio>

int main(int argc, char **argv) {

  // Produce gdml with G4
  GeoExample geo;
  G4VPhysicalVolume *physVolume = geo.Construct();
  G4GDMLParser parser;
  parser.SetAddPointerToName(true);
  remove("GeoExample.g4.gdml");
  parser.Write("GeoExample.g4.gdml", physVolume, true,
               "http://service-spi.web.cern.ch/service-spi/app/releases/GDML/schema/gdml.xsd");

  // Produce TGeo and gdml with VGM
  Geant4GM::Factory *g4Factory = new Geant4GM::Factory();
  g4Factory->Import(physVolume);
  RootGM::Factory *rtFactory = new RootGM::Factory();
  g4Factory->Export(rtFactory);
  gGeoManager->CloseGeometry();
  gGeoManager->Export("GeoExample.vgm.root");
  gGeoManager->Export("GeoExample.vgm.gdml");

  return 0;
}
